'Placed in the Public Domain 5/24/97 John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 2.1 or higher to compile
'm100xca.bas - translates Radio Shack (Tandy) Model 100 Computer .CA
'files to ASCII for import.  Originally for Al Beverly's campaign notes
'Copyright (c) 1992 John E. Carter
'last update 09/19/92 (jec)
defint a-z
cls
SHARED x$, curfield$, currec, recnum, fieldnum, thisfield, recsdone, delim$
SHARED maxfield
x$ = "Model 100 CA File Translator - Copyright 1992 - John E. Carter"
call center(x$,80)
locate 1, 1
print x$
x$="johnecarter@mindspring.com"
call center(x$,80)
locate 2, 1
print x$

if command$ <> "" then
  cmd$ = ucase$(command$)
  mf$ = cmd$
else
  input "Name of Model 100 data file (xxxxxx.ca): ",mf$
  if mf$ = "" then end
end if
k$ = dir$(mf$)
if len(k$) = 0 then               'if file not found
  print "File ";mf$;" not found."
  end
else
  locate 2, 1
  print space$(79);
  locate 2, 1
  print "Reading file: ";mf$
end if
dotloc = instr(mf$,".")             ' "." in file name?
if dotloc > 0 then                                   'if so, extract basename
  of$ = rtrim$(left$(mf$,dotloc -1)) + ".txt"
else
  of$ = rtrim$(mf$) + ".txt"                        ' else just trim it
end if
st$ = time$
k$ = dir$(of$)
if len(k$) > 0 then
  beep
  print "Overwrite existing ";of$;" output file (Y/N): ";
  while not instat:wend
  ans$ = ucase$(inkey$)
  if ans$ > "@" then print ans$
  if ans$ <> "Y" then
    print
    print "Done"
    end
  end if
end if
open of$ for output as 2
open mf$ for binary as 1
get$ 1, 48, x$                   'skip some header
get$ 1, 1, x$
maxrec = ascii(x$) -1            ' # of records in file (? > 255)
get$ 1, 1, x$
maxfield = ascii(x$)             ' # of fields in record
get$ 1, 69, x$                   'skip some bytes
get$ 1, 8, x$
m100name$ = x$                    ' 8 chars, right padded
locate 3,1
print space$(79);
locate 3,1
print "Model 100 template: ";m100name$
locate 24,1
print "Records processed:";
get$ 1, 128, x$                   'skip some bytes
prevbyte = 99                     'dummy value
curbyte = 0
thisfield = 0
recsdone = 0
currec = 1
while curbyte <> 3            'skip over misc bytes  03 preceeds first rec
  get$ 1,1,x$
  curbyte = ascii(x$)
wend
while eof(1) <> -1
  get$ 1,1,x$
  recnum = ascii(x$)
  if recnum = 255 then
    call recend
    locate 24, 20
    print using "###";recsdone;
    close
    print
    print "Start: ";st$,"End: ";time$,, "Done"
    end
  end if
  get$ 1,1,x$
  fieldnum = ascii(x$)
  if thisfield <> 0 and fieldnum < thisfield then  'next record
    currec = recnum
    call recend                                  'put CR at end of line
    locate 24, 20
    print using "###";recsdone;
  end if
  if recnum = currec then  'get next field
    if thisfield > 0 then
      while fieldnum > thisfield + 1
	call padfield
	incr thisfield
      wend
    end if
    incr thisfield
    call getfield
  end if
wend
end

SUB recend                    'add <CR> at end of printed line
  while thisfield < maxfield
    call padfield
    incr thisfield
  wend
  print #2, ""
  incr recsdone
  thisfield = 0
'  delay .2
  for lin = 4 to 23
    locate lin,1
    print space$(79);
  next lin
END SUB 'recend

SUB getfield                  'get data from field and print to file
  curfield$ = ""              'clear string
  get$ 1,1,delim$             'delimiter for this string
  fieldlen = ascii(delim$) - 4
  curpos = 0
  get$ 1,1,t$
  if t$ = "'" then
    incr curpos
    get$ 1,1,t$
  end if
  while curpos < fieldlen
    incr curpos
    curfield$ = curfield$ + t$
    get$ 1,1,t$
  wend
  if thisfield <> 1 then
    print #2, ",";
  end if
  print #2, chr$(34);curfield$;chr$(34);   'comma delimited for dBASE
  locate fieldnum+3,1
  print curfield$
END SUB 'getfield

SUB padfield                  'fill for missing data fields
  print #2, ",";chr$(34);chr$(34);
END SUB 'padfield

SUB center(x$,fldwidth)
  k = fldwidth - len(x$)
  x$ = space$(k/2) + x$
END SUB 'center
